Index: /pjproject/trunk/aconfigure.ac
===================================================================
--- /pjproject/trunk/aconfigure.ac	(revision 5309)
+++ /pjproject/trunk/aconfigure.ac	(revision 5310)
@@ -1,3 +1,3 @@
-AC_INIT(pjproject,2.x)
+AC_INIT([pjproject],[2.x])
 
 host_orig="$host"
@@ -39,5 +39,5 @@
 AC_PROG_CC
 AC_PROG_CXX
-AC_LANG_C
+AC_LANG([C])
 
 AC_PROG_RANLIB
@@ -181,5 +181,5 @@
 dnl # --disable-floating-point option
 AC_ARG_ENABLE(floating-point,
-	      AC_HELP_STRING([--disable-floating-point],
+	      AS_HELP_STRING([--disable-floating-point],
 			     [Disable floating point where possible]),
 	      [if test "$enable_floating_point" = "no"; then
@@ -413,5 +413,5 @@
 AC_MSG_CHECKING([ioqueue backend])
 AC_ARG_ENABLE(epoll,
-	      AC_HELP_STRING([--enable-epoll],
+	      AS_HELP_STRING([--enable-epoll],
 			     [Use /dev/epoll ioqueue on Linux (experimental)]),
 	      [
@@ -429,5 +429,5 @@
 AC_SUBST(ac_shared_libraries)
 AC_ARG_ENABLE(shared,
-	      AC_HELP_STRING([--enable-shared],
+	      AS_HELP_STRING([--enable-shared],
 			     [Build shared libraries]),
 	      [if test "$enable_shared" = "yes"; then
@@ -484,5 +484,5 @@
 AC_SUBST(ac_external_speex,0)
 AC_ARG_WITH(external-speex,
-    AC_HELP_STRING([--with-external-speex],
+    AS_HELP_STRING([--with-external-speex],
 		   [Use external Speex development files, not the one in "third_party" directory. When this option is set, make sure that Speex is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -506,5 +506,5 @@
 AC_SUBST(ac_external_gsm,0)
 AC_ARG_WITH(external-gsm,
-    AC_HELP_STRING([--with-external-gsm],
+    AS_HELP_STRING([--with-external-gsm],
 		   [Use external GSM codec library, not the one in "third_party" directory. When this option is set, make sure that the GSM include/lib files are accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -542,5 +542,5 @@
 AC_SUBST(ac_external_srtp,0)
 AC_ARG_WITH(external-srtp,
-    AC_HELP_STRING([--with-external-srtp],
+    AS_HELP_STRING([--with-external-srtp],
 		   [Use external SRTP development files, not the one in "third_party" directory. When this option is set, make sure that SRTP is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -572,5 +572,5 @@
 AC_SUBST(ac_pjmedia_resample,libresample)
 AC_ARG_ENABLE(resample,
-	      AC_HELP_STRING([--disable-resample],
+	      AS_HELP_STRING([--disable-resample],
 			     [Disable resampling implementations]),
 	      [if test "$enable_resample" = "no"; then
@@ -583,5 +583,5 @@
 AC_SUBST(ac_pjmedia_snd)
 AC_ARG_ENABLE(sound,
-	      AC_HELP_STRING([--disable-sound],
+	      AS_HELP_STRING([--disable-sound],
 			     [Exclude sound (i.e. use null sound)]),
 	      [if test "$enable_sound" = "no"; then
@@ -594,5 +594,5 @@
 AC_SUBST(ac_external_pa,0)
 AC_ARG_WITH(external-pa,
-    AC_HELP_STRING([--with-external-pa],
+    AS_HELP_STRING([--with-external-pa],
 		   [Use external PortAudio development files, not the one in "third_party" directory. When this option is set, make sure that PortAudio is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -672,5 +672,5 @@
 	AC_SUBST(ac_pa_use_oss,1)
 	AC_ARG_ENABLE(oss,
-		      AC_HELP_STRING([--disable-oss],
+		      AS_HELP_STRING([--disable-oss],
 				     [Disable OSS audio (default: not disabled)]),
 		      [
@@ -688,5 +688,5 @@
 dnl # --disable-video option
 AC_ARG_ENABLE(video,
-	      AC_HELP_STRING([--disable-video],
+	      AS_HELP_STRING([--disable-video],
 	      		     [Disable video feature]),
 	      [if test "$enable_video" = "no"; then
@@ -770,5 +770,5 @@
 
 AC_ARG_ENABLE(ext_sound,
-	      AC_HELP_STRING([--enable-ext-sound],
+	      AS_HELP_STRING([--enable-ext-sound],
 			     [PJMEDIA will not provide any sound device backend]),
 	      [if test "$enable_ext_sound" = "yes"; then
@@ -781,5 +781,5 @@
 AC_SUBST(ac_no_small_filter)
 AC_ARG_ENABLE(small-filter,
-	      AC_HELP_STRING([--disable-small-filter],
+	      AS_HELP_STRING([--disable-small-filter],
 			     [Exclude small filter in resampling]),
 	      [if test "$enable_small_filter" = "no"; then
@@ -792,5 +792,5 @@
 AC_SUBST(ac_no_large_filter)
 AC_ARG_ENABLE(large-filter,
-	      AC_HELP_STRING([--disable-large-filter],
+	      AS_HELP_STRING([--disable-large-filter],
 			     [Exclude large filter in resampling]),
 	      [if test "$enable_large_filter" = "no"; then
@@ -803,5 +803,5 @@
 AC_SUBST(ac_no_speex_aec)
 AC_ARG_ENABLE(speex-aec,
-	      AC_HELP_STRING([--disable-speex-aec],
+	      AS_HELP_STRING([--disable-speex-aec],
 			     [Exclude Speex Acoustic Echo Canceller/AEC]),
 	      [if test "$enable_speex_aec" = "no"; then
@@ -814,5 +814,5 @@
 AC_SUBST(ac_no_g711_codec)
 AC_ARG_ENABLE(g711-codec,
-	      AC_HELP_STRING([--disable-g711-codec],
+	      AS_HELP_STRING([--disable-g711-codec],
 			     [Exclude G.711 codecs from the build]),
 	      [if test "$enable_g711_codec" = "no"; then
@@ -827,5 +827,5 @@
 AC_SUBST(ac_no_l16_codec)
 AC_ARG_ENABLE(l16-codec,
-	      AC_HELP_STRING([--disable-l16-codec],
+	      AS_HELP_STRING([--disable-l16-codec],
 			     [Exclude Linear/L16 codec family from the build]),
 	      [if test "$enable_l16_codec" = "no"; then
@@ -840,5 +840,5 @@
 AC_SUBST(ac_no_gsm_codec)
 AC_ARG_ENABLE(gsm-codec,
-	      AC_HELP_STRING([--disable-gsm-codec],
+	      AS_HELP_STRING([--disable-gsm-codec],
 			     [Exclude GSM codec in the build]),
 	      [if test "$enable_gsm_codec" = "no"; then
@@ -852,5 +852,5 @@
 AC_SUBST(ac_no_g722_codec)
 AC_ARG_ENABLE(g722-codec,
-	      AC_HELP_STRING([--disable-g722-codec],
+	      AS_HELP_STRING([--disable-g722-codec],
 			     [Exclude G.722 codec in the build]),
 	      [if test "$enable_g722_codec" = "no"; then
@@ -864,5 +864,5 @@
 AC_SUBST(ac_no_g7221_codec)
 AC_ARG_ENABLE(g7221-codec,
-	      AC_HELP_STRING([--disable-g7221-codec],
+	      AS_HELP_STRING([--disable-g7221-codec],
 			     [Exclude G.7221 codec in the build]),
 	      [if test "$enable_g7221_codec" = "no"; then
@@ -876,5 +876,5 @@
 AC_SUBST(ac_no_speex_codec)
 AC_ARG_ENABLE(speex-codec,
-	      AC_HELP_STRING([--disable-speex-codec],
+	      AS_HELP_STRING([--disable-speex-codec],
 			     [Exclude Speex codecs in the build]),
 	      [if test "$enable_speex_codec" = "no"; then
@@ -888,5 +888,5 @@
 AC_SUBST(ac_no_ilbc_codec)
 AC_ARG_ENABLE(ilbc-codec,
-	      AC_HELP_STRING([--disable-ilbc-codec],
+	      AS_HELP_STRING([--disable-ilbc-codec],
 			     [Exclude iLBC codec in the build]),
 	      [if test "$enable_ilbc_codec" = "no"; then
@@ -899,5 +899,5 @@
 dnl # Include libsamplerate
 AC_ARG_ENABLE(libsamplerate,
-           AC_HELP_STRING([--enable-libsamplerate],
+           AS_HELP_STRING([--enable-libsamplerate],
                     [Link with libsamplerate when available.]),
            [
@@ -913,5 +913,5 @@
 AC_SUBST(ac_resample_dll)
 AC_ARG_ENABLE(resample_dll,
-	      AC_HELP_STRING([--enable-resample-dll],
+	      AS_HELP_STRING([--enable-resample-dll],
 			     [Build libresample as shared library]),
 	      [if test "$enable_resample_dll" = "yes"; then
@@ -924,5 +924,5 @@
 dnl # SDL alt prefix
 AC_ARG_WITH(sdl,
-    AC_HELP_STRING([--with-sdl=DIR],
+    AS_HELP_STRING([--with-sdl=DIR],
 		   [Specify alternate libSDL prefix]),
     [],
@@ -937,5 +937,5 @@
 dnl # SDL
 AC_ARG_ENABLE(sdl,
-	      AC_HELP_STRING([--disable-sdl],
+	      AS_HELP_STRING([--disable-sdl],
 			     [Disable SDL (default: not disabled)]),
 	      [
@@ -969,5 +969,5 @@
 
 AC_ARG_WITH(ffmpeg,
-    AC_HELP_STRING([--with-ffmpeg=DIR],
+    AS_HELP_STRING([--with-ffmpeg=DIR],
 		   [Specify alternate FFMPEG prefix]),
     [],
@@ -982,5 +982,5 @@
 dnl # FFMPEG stuffs
 AC_ARG_ENABLE(ffmpeg,
-	      AC_HELP_STRING([--disable-ffmpeg],
+	      AS_HELP_STRING([--disable-ffmpeg],
 			     [Disable ffmpeg (default: not disabled)]),
 	      [
@@ -1107,5 +1107,5 @@
 dnl # Video for Linux 2
 AC_ARG_ENABLE(v4l2,
-	      AC_HELP_STRING([--disable-v4l2],
+	      AS_HELP_STRING([--disable-v4l2],
 			     [Disable Video4Linux2 (default: not disabled)]),
 	      [
@@ -1128,5 +1128,5 @@
 dnl # OpenH264 alt prefix
 AC_ARG_WITH(openh264,
-            AC_HELP_STRING([--with-openh264=DIR],
+            AS_HELP_STRING([--with-openh264=DIR],
 		           [Specify alternate OpenH264 prefix]),
             [],
@@ -1143,5 +1143,5 @@
 AC_SUBST(ac_openh264_ldflags)
 AC_ARG_ENABLE(openh264,
-	      AC_HELP_STRING([--disable-openh264],
+	      AS_HELP_STRING([--disable-openh264],
 			     [Disable OpenH264 (default: not disabled)]),
 	      [
@@ -1193,5 +1193,5 @@
 dnl # libyuv alt prefix
 AC_ARG_WITH(libyuv,
-            AC_HELP_STRING([--with-libyuv=DIR],
+            AS_HELP_STRING([--with-libyuv=DIR],
 		           [Specify alternate libyuv prefix]),
             [],
@@ -1208,5 +1208,5 @@
 AC_SUBST(ac_libyuv_ldflags)
 AC_ARG_ENABLE(libyuv,
-	      AC_HELP_STRING([--disable-libyuv],
+	      AS_HELP_STRING([--disable-libyuv],
 			     [Exclude libyuv in the build]),
 	      [if test "$enable_libyuv" = "no"; then
@@ -1270,5 +1270,5 @@
 dnl # WebRtc alt prefix
 AC_ARG_WITH(webrtc,
-            AC_HELP_STRING([--with-webrtc=DIR],
+            AS_HELP_STRING([--with-webrtc=DIR],
 		           [Specify alternate WebRtc prefix]),
             [],
@@ -1285,5 +1285,5 @@
 AC_SUBST(ac_webrtc_ldflags)
 AC_ARG_ENABLE(webrtc,
-	      AC_HELP_STRING([--disable-webrtc],
+	      AS_HELP_STRING([--disable-webrtc],
 			     [Exclude webrtc in the build]),
 	      [if test "$enable_webrtc" = "no"; then
@@ -1348,5 +1348,5 @@
 dnl #
 AC_ARG_ENABLE(ipp,
-    AC_HELP_STRING([--enable-ipp],
+    AS_HELP_STRING([--enable-ipp],
 		   [Enable Intel IPP support. Specify the Intel IPP package and samples location using IPPROOT and IPPSAMPLES env var or with --with-ipp and --with-ipp-samples options]),
     [],
@@ -1355,5 +1355,5 @@
 
 AC_ARG_WITH(ipp,
-    AC_HELP_STRING([--with-ipp=DIR],
+    AS_HELP_STRING([--with-ipp=DIR],
 		   [Specify the Intel IPP location]),
     [],
@@ -1362,5 +1362,5 @@
 
 AC_ARG_WITH(ipp-samples,
-    AC_HELP_STRING([--with-ipp-samples=DIR],
+    AS_HELP_STRING([--with-ipp-samples=DIR],
 		   [Specify the Intel IPP samples location]),
     [],
@@ -1369,5 +1369,5 @@
 
 AC_ARG_WITH(ipp-arch,
-    AC_HELP_STRING([--with-ipp-arch=ARCH],
+    AS_HELP_STRING([--with-ipp-arch=ARCH],
 		   [Specify the Intel IPP ARCH suffix, e.g. "64" or "em64t. Default is blank for IA32"]),
     [],
@@ -1587,5 +1587,5 @@
 dnl # SSL alt prefix
 AC_ARG_WITH(ssl,
-    AC_HELP_STRING([--with-ssl=DIR],
+    AS_HELP_STRING([--with-ssl=DIR],
 		   [Specify alternate libssl prefix]),
     [],
@@ -1601,5 +1601,5 @@
 AC_SUBST(ac_no_ssl)
 AC_ARG_ENABLE(ssl,
-	      AC_HELP_STRING([--disable-ssl],
+	      AS_HELP_STRING([--disable-ssl],
 			     [Exclude SSL support the build (default: autodetect)])
 	      ,
@@ -1635,5 +1635,5 @@
 dnl # Obsolete option --with-opencore-amrnb
 AC_ARG_WITH(opencore-amrnb,
-    AC_HELP_STRING([--with-opencore-amrnb=DIR],
+    AS_HELP_STRING([--with-opencore-amrnb=DIR],
 		   [This option is obsolete and replaced by --with-opencore-amr=DIR]),
     [AC_MSG_ERROR(This option is obsolete and replaced by --with-opencore-amr=DIR)],
@@ -1643,5 +1643,5 @@
 dnl # opencore-amr alt prefix
 AC_ARG_WITH(opencore-amr,
-    AC_HELP_STRING([--with-opencore-amr=DIR],
+    AS_HELP_STRING([--with-opencore-amr=DIR],
 		   [Specify alternate libopencore-amr prefix]),
     [],
@@ -1656,5 +1656,5 @@
 dnl # vo-amrwbenc alt prefix
 AC_ARG_WITH(opencore-amrwbenc,
-    AC_HELP_STRING([--with-opencore-amrwbenc=DIR],
+    AS_HELP_STRING([--with-opencore-amrwbenc=DIR],
 		   [Specify alternate libvo-amrwbenc prefix]),
     [],
@@ -1672,5 +1672,5 @@
 AC_SUBST(ac_no_opencore_amrwb)
 AC_ARG_ENABLE(opencore_amr,
-	      AC_HELP_STRING([--disable-opencore-amr],
+	      AS_HELP_STRING([--disable-opencore-amr],
 			     [Exclude OpenCORE AMR support from the build (default: autodetect)])
 	      ,
@@ -1727,5 +1727,5 @@
 dnl # SILK prefix
 AC_ARG_WITH(silk,
-    AC_HELP_STRING([--with-silk=DIR],
+    AS_HELP_STRING([--with-silk=DIR],
 		   [Specify alternate SILK prefix]),
     [],
@@ -1741,5 +1741,5 @@
 AC_SUBST(ac_no_silk)
 AC_ARG_ENABLE(silk,
-	      AC_HELP_STRING([--disable-silk],
+	      AS_HELP_STRING([--disable-silk],
 			     [Exclude SILK support from the build (default: autodetect)])
 	      ,
@@ -1779,5 +1779,5 @@
 dnl # OPUS prefix
 AC_ARG_WITH(opus,
-    AC_HELP_STRING([--with-opus=DIR],
+    AS_HELP_STRING([--with-opus=DIR],
 		   [Specify alternate OPUS prefix]),
     [],
@@ -1788,5 +1788,5 @@
 AC_SUBST(ac_no_opus)
 AC_ARG_ENABLE(opus,
-	      AC_HELP_STRING([--disable-opus],
+	      AS_HELP_STRING([--disable-opus],
 			     [Exclude OPUS support from the build (default: autodetect)])
 	      ,
@@ -1903,5 +1903,5 @@
 
 ac_build_mak_vars=`echo $ac_build_mak_vars | sed 's/\\\\n/\n/g'`
-AC_OUTPUT()
+AC_OUTPUT
 
 